using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Runtime.Serialization.Formatters.Binary;
using System.Collections;
using System.Security.Cryptography;
using System.Configuration;
using System.Threading;

namespace SOURCE
{
    public partial class Source : Form
    {
        int clusterIndex;
        string encryptedFileName;
        Hashtable ht;
        TcpListener listener;
        Socket mysock;
        NetworkStream mynws;
        object op;
        TcpListener tcp;
        NetworkStream myns;

        TcpListener mytcpl;

        Socket mysocket;

        Thread myth;
        Thread mythrd;
        IPAddress[] addr;
        string[] msg;
        string str;
        string ackIp;

        public Source()
        {
            InitializeComponent();
        }


        private void btnBrowse_Click(object sender, EventArgs e)
        {
            openFileDialog1.ShowDialog();
            txtSelectfile.Text = openFileDialog1.FileName;
        }
        private void btnSend_Click(object sender, EventArgs e)
        {
            Encrypt();
            PrepareSendFile();
            curent();

        }

        private void PrepareSendFile()
        {
            int prevClusterIndex = clusterIndex;
            int check = 1;
            while (check != (ht.Count + 1))
            {
                if (clusterIndex == ht.Count)
                {
                    clusterIndex = 0;
                }
                bool sent = SendFile(ht, clusterIndex);
                clusterIndex++;

                if (sent == true)
                    break;
                check++;
            }
            if (clusterIndex == 1 && check == 1)
            {
                //getdata5();
                //Receiver();
                string ip = textBox3.Text;
                MessageBox.Show("Msg Sending Via," + ip + "");

            }
            if (clusterIndex == 2 && check == 1)
            {
                MessageBox.Show("" + textBox3.Text + " this node is busy,msg sending Via," + textBox4.Text + "");
            }

            if (check == 3)
            {
                MessageBox.Show("both the clusters are busy. Please try after some time");
                clusterIndex = prevClusterIndex;
            }
        }

        public void Encrypt()
        {
            string downloadDir = ConfigurationManager.AppSettings["uploadPath"];
            encryptedFileName = downloadDir + "\\" + System.IO.Path.GetFileName(txtSelectfile.Text.Trim());

            FileStream filestr = File.Create(encryptedFileName);
            TripleDESCryptoServiceProvider trdesc = new TripleDESCryptoServiceProvider();
            trdesc.KeySize = 128;
            byte[] key = new byte[] {0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,
                                      0x09,0x10,0x11,0x12,0x13,0x14,0x15,0x16};
            byte[] iv = new byte[] {0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,
                                      0x09,0x10,0x11,0x12,0x13,0x14,0x15,0x16};

            CryptoStream crstream = new CryptoStream(filestr, trdesc.CreateEncryptor(key, iv), CryptoStreamMode.Write);

            StreamWriter cryptoStreamWriter = new StreamWriter(crstream);
            StreamReader streamReader = new StreamReader(txtSelectfile.Text);
            string currline = streamReader.ReadLine();
            while (currline != null)
            {
                cryptoStreamWriter.Write(currline);
                currline = streamReader.ReadLine();
            }
            streamReader.Close();
            cryptoStreamWriter.Flush();
            cryptoStreamWriter.Close();
        }

        public bool SendFile(Hashtable ht, int clusterIndex)
        {
            bool check = checkNoTraffic(ht, clusterIndex);
            if (check == false)
                return false;

            string auxiliaryInfo = string.Empty;
            byte[] buffer;
            byte[] b1;
            string[] s = ht[clusterIndex].ToString().Split(new char[] { ';' });
            string ip = s[0];

            buffer = File.ReadAllBytes(encryptedFileName);
            TcpClient tclient = new TcpClient(ip, 8085);
            NetworkStream netstream = tclient.GetStream();

            auxiliaryInfo = txtDIpaddress.Text.Trim();
            auxiliaryInfo += ",";
            auxiliaryInfo += System.IO.Path.GetFileName(encryptedFileName);
            b1 = System.Text.Encoding.ASCII.GetBytes(auxiliaryInfo);

            BinaryWriter bwr = new BinaryWriter(netstream);
            bwr.Write(buffer.Length);
            bwr.Write(b1.Length);
            bwr.Write(b1);
            bwr.Write(buffer);
            bwr.Close();

            netstream.Close();
            ht[clusterIndex] = ip + ";false";
            return true;
        }

        private bool checkNoTraffic(Hashtable ht, int clusterIndex)
        {
            string[] s = ht[clusterIndex].ToString().Split(new char[] { ';' });
            if (s[1].Trim() == "true")
                return true;
            else
                return false;
        }
        private void Source_Load(object sender, EventArgs e)
        {
            txtDIpaddress.Text = SetNodes.dip;
            textBox3.Text = SetNodes.c1ip;
            textBox4.Text = SetNodes.c2ip;

            ht = new Hashtable();
            ht.Add(0, SetNodes.c1ip + ";true");
            ht.Add(1, SetNodes.c2ip + ";true");

            ThreadStart ts = new ThreadStart(buildhash);
            Thread t = new Thread(ts);
            t.IsBackground = true;
            t.Start();            
            //backgroundWorker1.RunWorkerAsync();
           backgroundWorker2.RunWorkerAsync();
            //// open();

        }

        private void buildhash()
        {
            listener = new TcpListener(IPAddress.Any, 4000);
            listener.Start();
            while (true)
            {
                TcpClient client = listener.AcceptTcpClient();
                while (client.Available == 0) ;
                //NetworkStream stream = new NetworkStream(socket);
                NetworkStream stream = client.GetStream();

                BinaryReader br = new BinaryReader(stream);
                byte[] bytes = br.ReadBytes(client.Available);
                //string ip = System.Text.Encoding.ASCII.GetString(bytes);
                string ip = ((IPEndPoint)client.Client.RemoteEndPoint).Address.ToString();

                int key = 0;
                foreach (DictionaryEntry d in ht)
                {
                    string[] v = d.Value.ToString().Split(new char[] { ';' });
                    if (v[0] == ip)
                        key = (int)d.Key;
                }

                ht[key] = ip + ";true";
                br.Close();
                stream.Close();
                client.Close();
            }
            // listener.Stop();
        }


        private void Source_FormClosed(object sender, FormClosedEventArgs e)
        {
            listener.Stop();
            Application.Exit();
        }

        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            TcpListener tcplisten = new TcpListener(IPAddress.Any, 8085);
            tcplisten.Start();
            while (true)
            {
                Socket mysocket = tcplisten.AcceptSocket();
                NetworkStream myns = new NetworkStream(mysocket);
                MessageBox.Show("Data reached to designation");
            }
        }
        public void curent()
        {

        }

        private void backgroundWorker2_DoWork(object sender, DoWorkEventArgs e)
        {
            TcpListener tcplisten = new TcpListener(IPAddress.Any, 8085);
            tcplisten.Start();
            while (true)
            {
            
                Socket mysocket = tcplisten.AcceptSocket();
                ackIp = ((IPEndPoint)mysocket.RemoteEndPoint).Address.ToString();
                NetworkStream myns = new NetworkStream(mysocket);
                Thread.Sleep(4000);
                MessageBox.Show(ackIp + "is Busy");             

                }
        }      
      

        public void getdata5()
        {
            try
            {

                IPHostEntry ipHostInfo = Dns.GetHostEntry(textBox3.Text);
                IPAddress ipAddress = ipHostInfo.AddressList[0];
                IPEndPoint remoteEP = new IPEndPoint(ipAddress, 11000);
                Socket sender1 = new Socket(AddressFamily.InterNetwork,
                    SocketType.Stream, ProtocolType.Tcp);
                try
                {
                    Thread.Sleep(4000);
                    MessageBox.Show("'"+ textBox3.Text+"' node is busy.Send Via'" + textBox4.Text+"'");

                }
                catch (SocketException se)
                {
                    MessageBox.Show(" No nodes has been connected");

                }


            }
            catch
            {
                MessageBox.Show("not connected");

            }
        }




    }



}